/*
 * Header    :
 * File      : PlayerSocket.hxx
 * Auther    : Kosuke Shinoda
 * Since     : "2002-03-17 14:45:14 kshinoda"
 * Time-stamp: "2002-03-17 15:04:30 kshinoda"
 * Comment   :
 * End       :
 */
/*
 * Copyright (C) 2001,2002 SHINODA, Kosuke. Jaist,Japan & CARC, AIST, JAPAN
 * Copyright (C) 2001 NODA, Itsuki, CARC, AIST, JAPAN
 */

#ifndef __Chagamma_PlayerSocket_hxx__
#define __Chagamma_PlayerSocket_hxx__

class PlayerSocket : public SimplePlayer {
  
  using namespace Itk;
  using namespace Soccer;
  
public:
  virtual void act();
  virtual void say();

protected:

protected:
  //--------------------------------------------------
  // PlayerSocket:: FieldPlay
  virtual void beforekickoff_play(Int time = 0);
  virtual void playon_play();
  virtual void set_player(Bool offense = True);

  void drop_ball();

  Bool restart();

  //--------------------------------------------------
  // 
  virtual Bool needto_chase_ball(Bool without_goalie = False, Int n_th = 1);
  virtual Bool needto_receive_ball();
  virtual Bool needto_do_defence();

  //--------------------------------------------------
  //
  Bool ableto_keep_ball();
  
};

#endif //__Chagamma_PlayerSocket_hxx__
